db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide
JMP SpriteV : JMP SpriteH : JMP MarioCape : JMP MarioFireball
JMP TopCorner : JMP HeadInside : JMP BodyInside

MarioBelow:
MarioAbove:
MarioSide:

TopCorner:
HeadInside:
BodyInside:
	PHX		;Preserve X
	PHY		;Preserve Y
	JSR Code	;Jump to our code.
	PLY		;Pull back Y
	PLX		;Pull X
SpriteV:
SpriteH:

MarioCape:
MarioFireball:
	RTL		;Return.

	NoLevel:
	SEP #$20
	RTS
Code:

	LDX $010A

	REP #$20
	LDA $700400,x
	BEQ NoLevel
	CMP #$0100
	BEQ NoLevel
	SEP #$20
	
	LDA $5B		;Check if Level...
	AND #$01	;...is...
	BNE Vert	;vertical.
	LDY #$00	;Set the...
	BRA Pos		;...index.
Vert:
	LDY #$02	;Set the index.
Pos:
	LDX $95,y	;Load proper Mario screen position into X
Door:
	LDA $16		;Check if...
	AND #$08	;...Mario is...
	BEQ Sub		;...pressing up.
	LDA #$0F	;Give the door...
	STA $1DFC	;...sound effect.
Block:
	LDA $19D8,x	;Start with properties.
	ORA %#00000010
	STA $19D8,x
	LDA $19D8,x
	TAY
	PHX
	LDX $010A
	REP #$20	;Make the Accumulator 16-bit.
	LDA $700400,x	;Load the level to Accumulator.
	XBA		;Swap B and A.
	SEP #$20	;Go back to 8-bit mode for A.
	PLX
	CMP #$01	;Is the level starting with 01...
	BNE Skip	;...if it is, skip setting bit.
	TYA		;Transfer Y to A, A now has properties.
	ORA #$01	;Set the bit 0.
	BRA Jump	;Jump to store properties.
Skip:
	TYA		;Transfer Y to A, A now has properties.
	AND #$FE	;Clear bit 0.
Jump:
	STA $19D8,x	;Store the properties.
	LDA $19D8,x
	TAY
	PHX
	LDX $010A
	REP #$20	;Go to 16-bit mode for A.
	LDA $700400,x	;Load level number.
	SEP #$20	;Keep only the lower bit.
	PLX
	
	STA $19B8,x	;Store it to exit table.
	
	;REP #$20
	;LDA #$0105
	
	LDA $19D8,x
	AND %#11110010
	STA $19D8,x
	
	PHX
	LDX $010A
	LDA $700401,x
	CMP #$01
	BNE Submap
	PLX
	LDA #$F7
	STA $19D8,x
	BRA Finalize
	Submap:
	PLX
	LDA #$F6
	STA $19D8,x
	Finalize:
	
	;LDA #$FF
	;STA $19D8,x
	
	LDA #$01
	STA $1B93
	
	LDA #$06	;Load $06 to A.
	STA $71		;Store it to Mario's animation trigger.
	STZ $89		;Store zero to $89.
	STZ $88		;Store zero to the time Mario teleports.
Sub:
	RTS		;Go back to our wrapper.